# coding: utf-8

"""
    OurSky SDA

    The basic flow for a new organization is as follows: 1. View the available satellite targets with the [satellite targets](#tag/satellite-targets/[get]/v1/satellite-targets) endpoint. Copy the id of the target you want to observe. 2. Create an organization target with the [organization target](#tag/organization-targets/[get]/v1/organization-targets) endpoint. Use the id copied from above. 3. Create a webhook with the [webhook](#tag/webhooks/[post]/v1/communications/webhook) endpoint to receive TDMs automatically (preferred) or use the [tdms](#tag/tdms/[get]/v1/tdms) endpoint to poll for TDMs.

    The version of the OpenAPI document: 1.3.3750
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from ourskyai_sda_api.models.v1_survey_instruction_step import V1SurveyInstructionStep

class V1SurveyInstruction(BaseModel):
    """
    V1SurveyInstruction
    """
    id: StrictStr = Field(...)
    node_id: Optional[StrictStr] = Field(None, alias="nodeId")
    target_id: StrictStr = Field(..., alias="targetId")
    first_step_at: Optional[datetime] = Field(None, alias="firstStepAt")
    steps: conlist(V1SurveyInstructionStep) = Field(..., description="Each step indicates a sidereal observation attempt at a given (Ra, Dec). When supplying coordinates, they should be given in J2000 reference frames using an SGP4 model for propagation.")
    __properties = ["id", "nodeId", "targetId", "firstStepAt", "steps"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1SurveyInstruction:
        """Create an instance of V1SurveyInstruction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in steps (list)
        _items = []
        if self.steps:
            for _item in self.steps:
                if _item:
                    _items.append(_item.to_dict())
            _dict['steps'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1SurveyInstruction:
        """Create an instance of V1SurveyInstruction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1SurveyInstruction.parse_obj(obj)

        _obj = V1SurveyInstruction.parse_obj({
            "id": obj.get("id"),
            "node_id": obj.get("nodeId"),
            "target_id": obj.get("targetId"),
            "first_step_at": obj.get("firstStepAt"),
            "steps": [V1SurveyInstructionStep.from_dict(_item) for _item in obj.get("steps")] if obj.get("steps") is not None else None
        })
        return _obj


